//
// Authors:
//   Patrick Cernko <errror@ps.uni-sb.de>
//
// Copyright:
//   Patrick Cernko, 2004
//
// Last Change:
//   $Date: 2004/01/21 15:40:14 $ by $Author: errror $
//   $Revision: 1.1 $
//

#if defined(INTERFACE)
#pragma implementation "AEPrintFrame.hh"
#endif

#include "AEPrintFrame.hh"

////////////////////////////////////////////////////////////////////////////////
// AEPrintFrame
////////////////////////////////////////////////////////////////////////////////
AEPrintFrame* AEPrintFrame::New(Thread* thread,
                                Interpreter* interpreter) {
  // create a frame on the given thread, using the given interpreter
  // reas as: StackFrame* frame = thread->CreateStackFrameUsingInterpreter(interpreter, SIZE);
  NEW_THREAD_STACK_FRAME(frame, thread, interpreter, SIZE);
  // comment: SIZE is the LAST enum in our member enum, so we have
  // ((int) SIZE) members!

  // return correctly typed frame
  return STATIC_CAST(AEPrintFrame *, frame);
}

AEPrintFrame* AEPrintFrame::New(Interpreter* interpreter) {
  // create a frame, using the given interpreter
  // reas as:
  // StackFrame* frame = cur_thread->CreateStackFrameUsingInterpreter(interpreter, SIZE);
  NEW_STACK_FRAME(frame, interpreter, SIZE);
  // comment: SIZE is the LAST enum in our member enum, so we have
  // ((int) SIZE) members!

  // return correctly typed frame
  return STATIC_CAST(AEPrintFrame *, frame);
}

u_int AEPrintFrame::GetSize() {
  // the size of this frame is the size of the inherited StackFrame
  // plus the number of members we have, provided as last enum in the
  // members enum!
  return StackFrame::GetSize() + SIZE;
}
////////////////////////////////////////////////////////////////////////////////
