//
// Authors:
//   Patrick Cernko <errror@ps.uni-sb.de>
//
// Copyright:
//   Patrick Cernko, 2004
//
// Last Change:
//   $Date: 2004/01/21 15:40:14 $ by $Author: errror $
//   $Revision: 1.1 $
//

#ifndef __AE__AE_PRINT_FRAME_HH__
#define __AE__AE_PRINT_FRAME_HH__

#if defined(INTERFACE)
#pragma interface "AEPrintFrame.hh"
#endif

#include "Base.hh"

/**
 * \class AEPrintFrame
 *
 * A StackFrame for the AEPrintInterpreter.
 */
class AEPrintFrame
  : private StackFrame {

private:
  // member enum
  enum { 
    SIZE           ///! last position, always the size
  };

public:
  /**
   * a "Constructor":
   * this one is meant to be called only on startup. It is created on
   * the given thread with the given interpreter and the arithmetic
   * expression to be stored in it.
   *
   * \param thread      The thread on which the frame should be created.
   * \param interpreter The interpreter for this frame.
   */
  static AEPrintFrame* New(Thread* thread, Interpreter* interpreter);

  /**
   * a "Constructor":
   * this is th "normal" one. It is created with the given interpreter
   * and the arithmetic expression to be stored in it.
   *
   * \param interpreter The interpreter for this frame.
   */
  static AEPrintFrame* New(Interpreter* interpreter);

  /**
   * the size of this frame.
   * \returns the size of this frame.
   */
  u_int GetSize();
};

#endif
