//
// Authors:
//   Patrick Cernko <errror@ps.uni-sb.de>
//
// Copyright:
//   Patrick Cernko, 2004
//
// Last Change:
//   $Date: 2004/01/21 15:57:11 $ by $Author: errror $
//   $Revision: 1.2 $
//

#if defined(INTERFACE)
#pragma implementation "AEPrintInterpreter.hh"
#endif

#include "AEPrintInterpreter.hh"
#include "AEPrintFrame.hh"

#include <cstdio>   // fprintf()


////////////////////////////////////////////////////////////////////////////////
// AEPrintInterpreter
////////////////////////////////////////////////////////////////////////////////
// initializing of the static members
AEPrintInterpreter* AEPrintInterpreter::self;

void AEPrintInterpreter::Init() {
  // create a Interpreter and store it in the "singleton" variable
  self = new AEPrintInterpreter();
  // XXX: what if self already contains a interpreter, who makes the gc?
}

void AEPrintInterpreter::PushCall(Closure*) {
  // do I need this?
//   AEClosure* closure = STATIC_CAST(AEClosure *, closure0);
//   AEPrintFrame::New(self, closure->GetRecord(), closure->GetLabel());
}

u_int AEPrintInterpreter::GetFrameSize(StackFrame* sFrame) {
  // make the StackFrame a AEPrintFrame
  AEPrintFrame* frame = STATIC_CAST(AEPrintFrame *, sFrame);
  // assertion: this frame must assoziated with US!
  Assert(sFrame->GetWorker() == this);
  // return it's size
  return frame->GetSize();
}

Worker::Result AEPrintInterpreter::Run(StackFrame* sFrame) {
  // make the StackFrame a AEPrintFrame
  AEPrintFrame* frame = STATIC_CAST(AEPrintFrame *, sFrame);
  // assertion: this frame must assoziated with US!
  Assert(sFrame->GetWorker() == this);

  if ((frame != INVALID_POINTER) && (Scheduler::nArgs > 0)) {
    fprintf(stderr, "Result of the expression is: %d\n", Store::WordToInt(Scheduler::currentArgs[0]));
  } else {
    fprintf(stderr, "Did not find a result on the Scheduler's args!\n");
  }

  // we always ...
  return Worker::EXIT;
}

u_int AEPrintInterpreter::GetInArity(ConcreteCode*) {
  // only dummy
  return 0;
}

u_int AEPrintInterpreter::GetOutArity(ConcreteCode*) {
  // only dummy
  return 1;
}

const char* AEPrintInterpreter::Identify() {
  // yes, we are a ...
  return "AEPrintInterpreter";
}

void AEPrintInterpreter::DumpFrame(StackFrame* // sFrame
                                  ) {
//   // make the StackFrame a AEPrintFrame
//   AEPrintFrame* frame = STATIC_CAST(AEPrintFrame *, sFrame);
//   // assertion: this frame must assoziated with US!
//   Assert(sFrame->GetWorker() == this);

//   // ok, what can we say about the frame? Hmm, only its ae, I think!
//   std::fprintf(stderr, "Select %s\n", frame->GetAE()->ExportC());
}
